/* eslint-disable semi */
'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.makeRequest = undefined;

var _request = require('request');

var _request2 = _interopRequireDefault(_request);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var makeRequest = function makeRequest(options, cb) {
  if (typeof cb !== 'function') {
    return new Promise(function (resolve, reject) {
      (0, _request2.default)(options, function (err, resp, body) {
        if (err) {
          reject(err);
        } else {
          resolve(body);
        }
      });
    });
  } else {
    (0, _request2.default)(options, function (err, resp, body) {
      if (err) return cb(err);
      if (body.error) return cb(body.error);
      cb(null, body);
    });
  }
};

exports.makeRequest = makeRequest;